#!/usr/bin/env bash

#source ~/.zshrc
source ~/.bashrc
source ~/.bash_profile

gen_dir='services_gen'
rm -R $gen_dir
mkdir $gen_dir

function install_service(){
	local service_name=$1
	local service_path="./AIOServices/$service_name.json"

	echo "using config $service_path"

	if [ ! -d "ios/Classes/Generated" ]; then
		mkdir 'ios/Classes/Generated'
	fi

#copy dart source

	if [ ! -d "lib/AIOService/" ]; then
		mkdir "lib/AIOService"
	fi

	if [ ! -d "lib/AIOService/$service_name" ]; then
		mkdir "lib/AIOService/$service_name"
	fi

	if [ ! -d "lib/AIOService/$service_name/handlers" ]; then
		mkdir "lib/AIOService/$service_name/handlers"
	fi

	if [ ! -d "lib/AIOService/$service_name/service" ]; then
		mkdir "lib/AIOService/$service_name/service"
	fi

	cp  $gen_dir/$service_name/dart/service/*.dart "lib/AIOService/$service_name/service/"
	cp  -n $gen_dir/$service_name/dart/handlers/*.dart "lib/AIOService/$service_name/handlers/"



#copy ios source
	if [ ! -d "ios/Classes/Generated/$service_name" ]; then
		mkdir "ios/Classes/Generated/$service_name"
	fi

	if [ ! -d "ios/Classes/Generated/$service_name/handlers" ]; then
		mkdir "ios/Classes/Generated/$service_name/handlers"
	fi

	if [ ! -d "ios/Classes/Generated/$service_name/service" ]; then
		mkdir "ios/Classes/Generated/$service_name/service"
	fi

	#copy service code override all.
	cp  $gen_dir/$service_name/oc/service/* "ios/Classes/Generated/$service_name/service/"
	#copy hanlders do not override because handlers could be modified.
	cp -n $gen_dir/$service_name/oc/handlers/* "ios/Classes/Generated/$service_name/handlers/"


#copy Android source
	if [ ! -d "../../android/app/src/business/flutterbridge/java/com/idlefish/flutterbridge/AIOService" ]; then
		mkdir "../../android/app/src/business/flutterbridge/java/com/idlefish/flutterbridge/AIOService"
	fi

	if [ ! -d "../../android/app/src/business/flutterbridge/java/com/idlefish/flutterbridge/AIOService/$service_name" ]; then
		mkdir "../../android/app/src/business/flutterbridge/java/com/idlefish/flutterbridge/AIOService/$service_name"
	fi

	cp  $gen_dir/$service_name/java/service/* "../../android/app/src/business/flutterbridge/java/com/idlefish/flutterbridge/AIOService/$service_name/"
	cp -n $gen_dir/$service_name/java/handlers/* "../../android/app/src/business/flutterbridge/java/com/idlefish/flutterbridge/AIOService/$service_name/"



#	'../../android/app/src/business/flutterbridge/java/com/idlefish/flutterbridge/AIOService'
#	'/Users/jidong/Documents/projects/Flutter/fwn_idlefish/pubs/aio_service'


	echo "service : $service_name installed"
}

service_list=""

# Yaml support
# Parse yml files into json first
for file in ServicesYaml/*.yml; do
	filename=$(basename -- "$file")
	extension="${filename##*.}"
	filename="${filename%.*}"
	echo "pasing yml $filename"
    bin/yaml2json_darwin_amd64 < ServicesYaml/$filename.yml > Services/$filename.json
done

for file in Services/*.json; do
	filename=$(basename -- "$file")
	extension="${filename##*.}"
	filename="${filename%.*}"
	echo "installing $filename"

	bin/xservice_kit_gen -out=$gen_dir -config=./Services -root-dir=.  -java-pkg=fleamarket.taobao.com.xservicekitexample.xservice

    #install_service "$filename"
done

cp -R services_gen/oc/* ../ios/Runner/XService/
cp -R services_gen/dart/* ../lib/
cp -R services_gen/java/  ../android/app/src/main/java/fleamarket/taobao/com/xservicekitexample/xservice/

cd -
